> For a complete documentation index, fetch https://docs.voximplant.ai/llms.txt

# SetKeyValueItem

POST https://api.voximplant.com/platform_api/SetKeyValueItem

Creates or updates a key-value pair. If an existing key is passed, the method returns the existing item and changes the value if needed. The keys should be unique within a Voximplant application.

Allowed roles: `Owner`, `Admin`, `Developer`.

**Example request:** SetKeyValueItem example.

Reference: https://docs.voximplant.ai/api-reference/management-api/reference/key-value-storage/set-key-value-item

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: management-api
  version: 1.0.0
paths:
  /SetKeyValueItem:
    post:
      operationId: set-key-value-item
      summary: SetKeyValueItem
      description: >-
        Creates or updates a key-value pair. If an existing key is passed, the
        method returns the existing item and changes the value if needed. The
        keys should be unique within a Voximplant application.


        Allowed roles: `Owner`, `Admin`, `Developer`.


        **Example request:** SetKeyValueItem example.
      tags:
        - subpackage_keyValueStorage
      parameters:
        - name: key
          in: query
          description: >-
            Key, up to 200 characters. A key can contain a namespace that is
            written before the ':' symbol, for example, test:1234. Thus,
            namespace 'test' can be used as a pattern in the
            [GetKeyValueItems](/api-reference/management-api/keyvaluestorage/getkeyvalueitems)
            and
            [GetKeyValueKeys](/api-reference/management-api/keyvaluestorage/getkeyvaluekeys)
            methods to find the keys with the same namespace.


            The key should match the following regular expression:
            `^[a-zA-Z0-9а-яА-ЯёЁ_\-:;.#+]*$`
          required: true
          schema:
            type: string
        - name: value
          in: query
          description: Value for the specified key, up to 2000 characters
          required: true
          schema:
            type: string
        - name: application_id
          in: query
          description: Application ID
          required: true
          schema:
            type: integer
        - name: application_name
          in: query
          description: Application name
          required: false
          schema:
            type: string
        - name: ttl
          in: query
          description: >-
            Key expiry time in seconds. The value is in range of 0..7,776,000
            (90 days), the default value is 30 days (2,592,000 seconds). The TTL
            is converted to an **expires_at** Unix timestamp field as part of
            the storage object. Note that one of the two parameters (ttl or
            expires_at) must be set
          required: false
          schema:
            type: integer
        - name: expires_at
          in: query
          description: >-
            Expiration date based on **ttl** (timestamp without milliseconds).
            Note that one of the two parameters (ttl or expires_at) must be set
          required: false
          schema:
            type: integer
        - name: Authorization
          in: header
          description: >-
            Voximplant Management API uses signed JWT tokens generated from your
            service-account private key. Pass the token in the `Authorization`
            header as a Bearer value:


            ```

            Authorization: Bearer $VOXIMPLANT_TOKEN

            ```


            See [Authorization](/api-reference/management-api/authorization) for
            ready-to-copy snippets in bash, Python, Node.js and Go that turn
            your `credentials.json` into a token.
          required: true
          schema:
            type: string
      responses:
        '200':
          description: Successful response
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/key-value-storage_SetKeyValueItem_Response_200
servers:
  - url: https://api.voximplant.com/platform_api
components:
  schemas:
    KeyValueItems:
      type: object
      properties:
        key:
          type: string
          description: Key that matches the specified key or key pattern
        value:
          type: string
          description: Value for the specified key
        expires_at:
          type: integer
          description: Expiration date based on **ttl** (timestamp without milliseconds)
      description: SetKeyValueItem, GetKeyValueItem, and GetKeyValueItems functions result.
      title: KeyValueItems
    key-value-storage_SetKeyValueItem_Response_200:
      type: object
      properties:
        result:
          $ref: '#/components/schemas/KeyValueItems'
          description: The key-value item
      title: key-value-storage_SetKeyValueItem_Response_200
  securitySchemes:
    JwtAuth:
      type: http
      scheme: bearer
      description: >-
        Voximplant Management API uses signed JWT tokens generated from your
        service-account private key. Pass the token in the `Authorization`
        header as a Bearer value:


        ```

        Authorization: Bearer $VOXIMPLANT_TOKEN

        ```


        See [Authorization](/api-reference/management-api/authorization) for
        ready-to-copy snippets in bash, Python, Node.js and Go that turn your
        `credentials.json` into a token.

```

## SDK Code Examples

```python Example 1
import requests

url = "https://api.voximplant.com/platform_api/SetKeyValueItem"

querystring = {"key":"key","value":"value","application_id":"1"}

headers = {"Authorization": "Bearer <token>"}

response = requests.post(url, headers=headers, params=querystring)

print(response.json())
```

```javascript Example 1
const url = 'https://api.voximplant.com/platform_api/SetKeyValueItem?key=key&value=value&application_id=1';
const options = {method: 'POST', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Example 1
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.voximplant.com/platform_api/SetKeyValueItem?key=key&value=value&application_id=1"

	req, _ := http.NewRequest("POST", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Example 1
require 'uri'
require 'net/http'

url = URI("https://api.voximplant.com/platform_api/SetKeyValueItem?key=key&value=value&application_id=1")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java Example 1
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.voximplant.com/platform_api/SetKeyValueItem?key=key&value=value&application_id=1")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php Example 1
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.voximplant.com/platform_api/SetKeyValueItem?key=key&value=value&application_id=1', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp Example 1
using RestSharp;

var client = new RestClient("https://api.voximplant.com/platform_api/SetKeyValueItem?key=key&value=value&application_id=1");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift Example 1
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.voximplant.com/platform_api/SetKeyValueItem?key=key&value=value&application_id=1")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```

```python Example 2
import requests

url = "https://api.voximplant.com/platform_api/SetKeyValueItem"

querystring = {"key":"key","value":"value","application_id":"1"}

headers = {"Authorization": "Bearer <token>"}

response = requests.post(url, headers=headers, params=querystring)

print(response.json())
```

```javascript Example 2
const url = 'https://api.voximplant.com/platform_api/SetKeyValueItem?key=key&value=value&application_id=1';
const options = {method: 'POST', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Example 2
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.voximplant.com/platform_api/SetKeyValueItem?key=key&value=value&application_id=1"

	req, _ := http.NewRequest("POST", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Example 2
require 'uri'
require 'net/http'

url = URI("https://api.voximplant.com/platform_api/SetKeyValueItem?key=key&value=value&application_id=1")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java Example 2
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.voximplant.com/platform_api/SetKeyValueItem?key=key&value=value&application_id=1")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php Example 2
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.voximplant.com/platform_api/SetKeyValueItem?key=key&value=value&application_id=1', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp Example 2
using RestSharp;

var client = new RestClient("https://api.voximplant.com/platform_api/SetKeyValueItem?key=key&value=value&application_id=1");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift Example 2
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.voximplant.com/platform_api/SetKeyValueItem?key=key&value=value&application_id=1")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```